DATA-DRIVEN KERNEL DESIGNS FOR OPTIMIZED GREEDY SCHEMES: A MACHINE LEARNING PERSPECTIVE
=========================================================================================

This repository contains the supplementary material for the publication
```
DATA-DRIVEN KERNEL DESIGNS FOR OPTIMIZED GREEDY SCHEMES: A MACHINE LEARNING PERSPECTIVE (2023)
T. Wenzel, F. Marchetti, E. Perracchione
```

It was used to carry out the numerical experiments and generate the figures for the publication.
The experiments were performed on Linux systems in 2023 and should work with Python versions of that time (e.g., `python3.7`).
The steps below each indicate a setup to be executed in a terminal, resulting in a URL printed to be opened in a browser to view and run the indicated notebooks.


## Installation

To create an virtual environment and install the required packages, simply run the `setup.sh` file.  \\
To activate the virtual environment, use `source venv/bin/activate`


## Downloading data

For the experiments described in Section 4.1, i.e. for the file [`section_4.1_compute_visualize.py`](`section_4.1_compute_visualize.py`), no data is required.
For the experiments described in the Sections 4.2 and 4.3, a data download is required, for which we make use of code from 
["bmdal_reg"](https://github.com/dholzmueller/bmdal_reg), see the code within the folder `utils_data`.

- To download the data (after activating the virtual environment), run `python3 download_data.py`


## Rerunning experiments and reproducing the plots

To rereun the numerical experiments of Section 4.2 and reproduce its plots, execute:

- [`section_4.2_compute.py`](`section_4.2_compute.py`)
- [`section_4.2_visualize.py`](section_4.2_visualize.py)

To rereun the numerical experiments of Section 4.3 and reproduce its plots, execute:

- [`section_4.3_compute.py`](section_4.3_compute.py)
- [`section_4.3_visualize.py`](section_4.3_visualize.py)




